/* Copyright(C) 2017 Cobac.Net All Rights Reserved. */
/* chapter: 8                          */
/* project: display                        */
/* outline: wb_t@C摜̕\ */
/* board  : DE1-SoC 24bittJ[Ή  */


#include "system.h"
#include "sys/alt_cache.h"
#include "altera_avalon_pio_regs.h"

#include "funamori.h"

#define DISPADDR PIO_0_BASE
#define CLRV_DON PIO_1_BASE
#define VBLANK   PIO_2_BASE
#define DISPON_BIT 0x01
#define CLRVB_BIT  0x02
#define VRAM ((volatile unsigned int *) 0x02000000)

/* VBLANK҂ */
void wait_vblank(void) {
    IOWR_ALTERA_AVALON_PIO_SET_BITS(CLRV_DON, CLRVB_BIT);
    IOWR_ALTERA_AVALON_PIO_CLEAR_BITS(CLRV_DON, CLRVB_BIT);
    while (IORD_ALTERA_AVALON_PIO_DATA(VBLANK)==0);
}

int main()
{
    char *data = header_data;
    unsigned char pic[3];
    int i;

    /* wb_t@CVRAMɓǂݍ */
    for ( i=0; i<width*height; i++ ) {
        HEADER_PIXEL(data, pic);
        VRAM[i] = (pic[0] << 16) | (pic[1] << 8) | pic[2];
    }
    alt_dcache_flush_all();

    /* \ON */
    wait_vblank();
    IOWR_ALTERA_AVALON_PIO_DATA(DISPADDR, 0x02000000);
    IOWR_ALTERA_AVALON_PIO_SET_BITS(CLRV_DON, DISPON_BIT);

  return 0;
}
